package com.foreverwin.mesnac.anomaly.controller;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.foreverwin.mesnac.anomaly.model.AbnormalBillDispose;
import com.foreverwin.mesnac.anomaly.service.AbnormalBillDisposeService;
import com.foreverwin.modular.core.util.FrontPage;
import com.foreverwin.modular.core.util.R;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import java.util.List;

/**
 *
 * @author zjw
 * @since 2021-08-12
 */
@RestController
@RequestMapping("/Z-ABNORMAL-BILL-DISPOSE")
public class AbnormalBillDisposeController {

    @Autowired
    public AbnormalBillDisposeService abnormalBillDisposeService;

    /**
    * 根据id查询
    *
    * @param id 主键
    * @return
    */
    @ResponseBody
    @GetMapping("/{id:.+}")
    public R getAbnormalBillDisposeById(@PathVariable String id) {
        return R.ok( abnormalBillDisposeService.getById(id));
    }

    /**
     * 查询所有数据
     *
     * @return
     */
    @ResponseBody
    @GetMapping("")
    public R getAbnormalBillDisposeList(AbnormalBillDispose abnormalBillDispose){
        List<AbnormalBillDispose> result;
        QueryWrapper<AbnormalBillDispose> queryWrapper = new QueryWrapper<>();
        queryWrapper.setEntity(abnormalBillDispose);
        result = abnormalBillDisposeService.list(queryWrapper);
        return R.ok(result);
    }

    /**
     * 分页查询数据
     *
     * @param frontPage  分页信息
     * @return
     */
    @ResponseBody
    @GetMapping("/page")
    public R page(FrontPage<AbnormalBillDispose> frontPage, AbnormalBillDispose abnormalBillDispose){
        IPage result;
        QueryWrapper<AbnormalBillDispose> queryWrapper = new QueryWrapper<>();
        queryWrapper.setEntity(abnormalBillDispose);
        if (frontPage.getGlobalQuery() != null && !"".equals(frontPage.getGlobalQuery().trim())) {
            //TODO modify global query
            queryWrapper.lambda().and(wrapper -> wrapper
                .like(AbnormalBillDispose::getHandle, frontPage.getGlobalQuery())
                .or().like(AbnormalBillDispose::getSite, frontPage.getGlobalQuery())
                .or().like(AbnormalBillDispose::getAbnormalBillBo, frontPage.getGlobalQuery())
                .or().like(AbnormalBillDispose::getDutyUser, frontPage.getGlobalQuery())
                .or().like(AbnormalBillDispose::getDutyDepart, frontPage.getGlobalQuery())
                .or().like(AbnormalBillDispose::getDutyType, frontPage.getGlobalQuery())
                .or().like(AbnormalBillDispose::getPrincipalUser, frontPage.getGlobalQuery())
                .or().like(AbnormalBillDispose::getDutyCauseDescription, frontPage.getGlobalQuery())
                .or().like(AbnormalBillDispose::getDutyCauseType, frontPage.getGlobalQuery())
                .or().like(AbnormalBillDispose::getDutySendUserGroup, frontPage.getGlobalQuery())
                .or().like(AbnormalBillDispose::getResolveUser, frontPage.getGlobalQuery())
                .or().like(AbnormalBillDispose::getAbnormalMethod, frontPage.getGlobalQuery())
                .or().like(AbnormalBillDispose::getRouterBo, frontPage.getGlobalQuery())
                .or().like(AbnormalBillDispose::getResolveShopOrder, frontPage.getGlobalQuery())
                .or().like(AbnormalBillDispose::getResolveRemark, frontPage.getGlobalQuery())
                .or().like(AbnormalBillDispose::getResolveSendUserGroup, frontPage.getGlobalQuery())
                .or().like(AbnormalBillDispose::getClosedUser, frontPage.getGlobalQuery())
                .or().like(AbnormalBillDispose::getAbnormalReason, frontPage.getGlobalQuery())
                .or().like(AbnormalBillDispose::getBeforeMeasure, frontPage.getGlobalQuery())
                .or().like(AbnormalBillDispose::getCreatedUser, frontPage.getGlobalQuery())
                .or().like(AbnormalBillDispose::getModifiedUser, frontPage.getGlobalQuery())
    );
        }
        result = abnormalBillDisposeService.page(frontPage.getPagePlus(), queryWrapper);
        return R.ok(result);
    }

    /**
     * 新增
     * @param abnormalBillDispose  传递的实体
     * @return  null 失败  实体成功
     */
    @PostMapping
    public R save(@RequestBody AbnormalBillDispose abnormalBillDispose) {
        return R.ok(abnormalBillDisposeService.save(abnormalBillDispose));
    }

    /**
     * 修改
     * @param abnormalBillDispose  传递的实体
     * @return  null 失败  实体成功
     */
    @PutMapping
    public R updateById(@RequestBody AbnormalBillDispose abnormalBillDispose) {
        return R.ok(abnormalBillDisposeService.updateById(abnormalBillDispose));
    }

    /**
     * 根据id删除对象
     * @param id  实体ID
     * @return 0 失败  1 成功
     */
    @ResponseBody
    @RequestMapping(method = RequestMethod.DELETE, value = "/{id:.+}")
    public R removeById(@PathVariable("id") String id){
        return R.ok(abnormalBillDisposeService.removeById(id));
    }

    /**
     * 批量删除对象
     * @param ids 实体集合ID
     * @return  0 失败  1 成功
     */
    @ResponseBody
    @RequestMapping(method = RequestMethod.POST, value = "/delete-batch")
    public R removeByIds(List<String> ids){
        return R.ok(abnormalBillDisposeService.removeByIds(ids));
    }
}